=begin
#Figshare API

#Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.32

=end

require 'date'

module SwaggerClient
  class Account
    # Account id
    attr_accessor :id

    # First Name
    attr_accessor :first_name

    # Last Name
    attr_accessor :last_name

    # Account used private quota
    attr_accessor :used_quota_private

    # Date of last account modification
    attr_accessor :modified_date

    # Account total used quota
    attr_accessor :used_quota

    # Date when account was created
    attr_accessor :created_date

    # Account quota
    attr_accessor :quota

    # Account group id
    attr_accessor :group_id

    # Account institution user id
    attr_accessor :institution_user_id

    # Account institution
    attr_accessor :institution_id

    # User email
    attr_accessor :email

    # Account public used quota
    attr_accessor :used_quota_public

    # True if a quota request is pending
    attr_accessor :pending_quota_request

    # Account activity status
    attr_accessor :active

    # Maximum upload size for account
    attr_accessor :maximum_file_size

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'first_name' => :'first_name',
        :'last_name' => :'last_name',
        :'used_quota_private' => :'used_quota_private',
        :'modified_date' => :'modified_date',
        :'used_quota' => :'used_quota',
        :'created_date' => :'created_date',
        :'quota' => :'quota',
        :'group_id' => :'group_id',
        :'institution_user_id' => :'institution_user_id',
        :'institution_id' => :'institution_id',
        :'email' => :'email',
        :'used_quota_public' => :'used_quota_public',
        :'pending_quota_request' => :'pending_quota_request',
        :'active' => :'active',
        :'maximum_file_size' => :'maximum_file_size'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'Integer',
        :'first_name' => :'String',
        :'last_name' => :'String',
        :'used_quota_private' => :'Integer',
        :'modified_date' => :'String',
        :'used_quota' => :'Integer',
        :'created_date' => :'String',
        :'quota' => :'Integer',
        :'group_id' => :'Integer',
        :'institution_user_id' => :'String',
        :'institution_id' => :'Integer',
        :'email' => :'String',
        :'used_quota_public' => :'Integer',
        :'pending_quota_request' => :'BOOLEAN',
        :'active' => :'Integer',
        :'maximum_file_size' => :'Integer'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'first_name')
        self.first_name = attributes[:'first_name']
      end

      if attributes.has_key?(:'last_name')
        self.last_name = attributes[:'last_name']
      end

      if attributes.has_key?(:'used_quota_private')
        self.used_quota_private = attributes[:'used_quota_private']
      end

      if attributes.has_key?(:'modified_date')
        self.modified_date = attributes[:'modified_date']
      end

      if attributes.has_key?(:'used_quota')
        self.used_quota = attributes[:'used_quota']
      end

      if attributes.has_key?(:'created_date')
        self.created_date = attributes[:'created_date']
      end

      if attributes.has_key?(:'quota')
        self.quota = attributes[:'quota']
      end

      if attributes.has_key?(:'group_id')
        self.group_id = attributes[:'group_id']
      end

      if attributes.has_key?(:'institution_user_id')
        self.institution_user_id = attributes[:'institution_user_id']
      end

      if attributes.has_key?(:'institution_id')
        self.institution_id = attributes[:'institution_id']
      end

      if attributes.has_key?(:'email')
        self.email = attributes[:'email']
      end

      if attributes.has_key?(:'used_quota_public')
        self.used_quota_public = attributes[:'used_quota_public']
      end

      if attributes.has_key?(:'pending_quota_request')
        self.pending_quota_request = attributes[:'pending_quota_request']
      end

      if attributes.has_key?(:'active')
        self.active = attributes[:'active']
      end

      if attributes.has_key?(:'maximum_file_size')
        self.maximum_file_size = attributes[:'maximum_file_size']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      if @first_name.nil?
        invalid_properties.push('invalid value for "first_name", first_name cannot be nil.')
      end

      if @last_name.nil?
        invalid_properties.push('invalid value for "last_name", last_name cannot be nil.')
      end

      if @used_quota_private.nil?
        invalid_properties.push('invalid value for "used_quota_private", used_quota_private cannot be nil.')
      end

      if @modified_date.nil?
        invalid_properties.push('invalid value for "modified_date", modified_date cannot be nil.')
      end

      if @used_quota.nil?
        invalid_properties.push('invalid value for "used_quota", used_quota cannot be nil.')
      end

      if @created_date.nil?
        invalid_properties.push('invalid value for "created_date", created_date cannot be nil.')
      end

      if @quota.nil?
        invalid_properties.push('invalid value for "quota", quota cannot be nil.')
      end

      if @group_id.nil?
        invalid_properties.push('invalid value for "group_id", group_id cannot be nil.')
      end

      if @institution_user_id.nil?
        invalid_properties.push('invalid value for "institution_user_id", institution_user_id cannot be nil.')
      end

      if @institution_id.nil?
        invalid_properties.push('invalid value for "institution_id", institution_id cannot be nil.')
      end

      if @email.nil?
        invalid_properties.push('invalid value for "email", email cannot be nil.')
      end

      if @used_quota_public.nil?
        invalid_properties.push('invalid value for "used_quota_public", used_quota_public cannot be nil.')
      end

      if @pending_quota_request.nil?
        invalid_properties.push('invalid value for "pending_quota_request", pending_quota_request cannot be nil.')
      end

      if @active.nil?
        invalid_properties.push('invalid value for "active", active cannot be nil.')
      end

      if @maximum_file_size.nil?
        invalid_properties.push('invalid value for "maximum_file_size", maximum_file_size cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @id.nil?
      return false if @first_name.nil?
      return false if @last_name.nil?
      return false if @used_quota_private.nil?
      return false if @modified_date.nil?
      return false if @used_quota.nil?
      return false if @created_date.nil?
      return false if @quota.nil?
      return false if @group_id.nil?
      return false if @institution_user_id.nil?
      return false if @institution_id.nil?
      return false if @email.nil?
      return false if @used_quota_public.nil?
      return false if @pending_quota_request.nil?
      return false if @active.nil?
      return false if @maximum_file_size.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          first_name == o.first_name &&
          last_name == o.last_name &&
          used_quota_private == o.used_quota_private &&
          modified_date == o.modified_date &&
          used_quota == o.used_quota &&
          created_date == o.created_date &&
          quota == o.quota &&
          group_id == o.group_id &&
          institution_user_id == o.institution_user_id &&
          institution_id == o.institution_id &&
          email == o.email &&
          used_quota_public == o.used_quota_public &&
          pending_quota_request == o.pending_quota_request &&
          active == o.active &&
          maximum_file_size == o.maximum_file_size
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, first_name, last_name, used_quota_private, modified_date, used_quota, created_date, quota, group_id, institution_user_id, institution_id, email, used_quota_public, pending_quota_request, active, maximum_file_size].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
