=begin
#Figshare API

#Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.32

=end

require 'date'

module SwaggerClient
  class CollectionCompletePrivate
    # Collection id
    attr_accessor :id

    # Collection title
    attr_accessor :title

    # Collection DOI
    attr_accessor :doi

    # Collection Handle
    attr_accessor :handle

    # Api endpoint
    attr_accessor :url

    # Various timeline dates
    attr_accessor :timeline

    # ID of the account owning the collection
    attr_accessor :account_id

    # Full Collection funding information
    attr_accessor :funding

    # Collection resource id
    attr_accessor :resource_id

    # Collection resource doi
    attr_accessor :resource_doi

    # Collection resource title
    attr_accessor :resource_title

    # Collection resource link
    attr_accessor :resource_link

    # Collection resource version
    attr_accessor :resource_version

    # Collection version
    attr_accessor :version

    # Collection description
    attr_accessor :description

    # List of collection categories
    attr_accessor :categories

    # List of collection references
    attr_accessor :references

    # List of collection tags
    attr_accessor :tags

    # List of collection authors
    attr_accessor :authors

    # Collection institution
    attr_accessor :institution_id

    # Collection group
    attr_accessor :group_id

    # Number of articles in collection
    attr_accessor :articles_count

    # True if collection is published
    attr_accessor :public

    # Collection citation
    attr_accessor :citation

    # Collection custom fields
    attr_accessor :custom_fields

    # Date when collection was last modified
    attr_accessor :modified_date

    # Date when collection was created
    attr_accessor :created_date

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'title' => :'title',
        :'doi' => :'doi',
        :'handle' => :'handle',
        :'url' => :'url',
        :'timeline' => :'timeline',
        :'account_id' => :'account_id',
        :'funding' => :'funding',
        :'resource_id' => :'resource_id',
        :'resource_doi' => :'resource_doi',
        :'resource_title' => :'resource_title',
        :'resource_link' => :'resource_link',
        :'resource_version' => :'resource_version',
        :'version' => :'version',
        :'description' => :'description',
        :'categories' => :'categories',
        :'references' => :'references',
        :'tags' => :'tags',
        :'authors' => :'authors',
        :'institution_id' => :'institution_id',
        :'group_id' => :'group_id',
        :'articles_count' => :'articles_count',
        :'public' => :'public',
        :'citation' => :'citation',
        :'custom_fields' => :'custom_fields',
        :'modified_date' => :'modified_date',
        :'created_date' => :'created_date'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'Integer',
        :'title' => :'String',
        :'doi' => :'String',
        :'handle' => :'String',
        :'url' => :'String',
        :'timeline' => :'Timeline',
        :'account_id' => :'Integer',
        :'funding' => :'Array<FundingInformation>',
        :'resource_id' => :'String',
        :'resource_doi' => :'String',
        :'resource_title' => :'String',
        :'resource_link' => :'String',
        :'resource_version' => :'Integer',
        :'version' => :'Integer',
        :'description' => :'String',
        :'categories' => :'Array<Category>',
        :'references' => :'Array<String>',
        :'tags' => :'Array<String>',
        :'authors' => :'Array<Author>',
        :'institution_id' => :'Integer',
        :'group_id' => :'Integer',
        :'articles_count' => :'Integer',
        :'public' => :'BOOLEAN',
        :'citation' => :'String',
        :'custom_fields' => :'Array<CustomArticleField>',
        :'modified_date' => :'String',
        :'created_date' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'title')
        self.title = attributes[:'title']
      end

      if attributes.has_key?(:'doi')
        self.doi = attributes[:'doi']
      end

      if attributes.has_key?(:'handle')
        self.handle = attributes[:'handle']
      end

      if attributes.has_key?(:'url')
        self.url = attributes[:'url']
      end

      if attributes.has_key?(:'timeline')
        self.timeline = attributes[:'timeline']
      end

      if attributes.has_key?(:'account_id')
        self.account_id = attributes[:'account_id']
      end

      if attributes.has_key?(:'funding')
        if (value = attributes[:'funding']).is_a?(Array)
          self.funding = value
        end
      end

      if attributes.has_key?(:'resource_id')
        self.resource_id = attributes[:'resource_id']
      end

      if attributes.has_key?(:'resource_doi')
        self.resource_doi = attributes[:'resource_doi']
      end

      if attributes.has_key?(:'resource_title')
        self.resource_title = attributes[:'resource_title']
      end

      if attributes.has_key?(:'resource_link')
        self.resource_link = attributes[:'resource_link']
      end

      if attributes.has_key?(:'resource_version')
        self.resource_version = attributes[:'resource_version']
      end

      if attributes.has_key?(:'version')
        self.version = attributes[:'version']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'categories')
        if (value = attributes[:'categories']).is_a?(Array)
          self.categories = value
        end
      end

      if attributes.has_key?(:'references')
        if (value = attributes[:'references']).is_a?(Array)
          self.references = value
        end
      end

      if attributes.has_key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.has_key?(:'authors')
        if (value = attributes[:'authors']).is_a?(Array)
          self.authors = value
        end
      end

      if attributes.has_key?(:'institution_id')
        self.institution_id = attributes[:'institution_id']
      end

      if attributes.has_key?(:'group_id')
        self.group_id = attributes[:'group_id']
      end

      if attributes.has_key?(:'articles_count')
        self.articles_count = attributes[:'articles_count']
      end

      if attributes.has_key?(:'public')
        self.public = attributes[:'public']
      end

      if attributes.has_key?(:'citation')
        self.citation = attributes[:'citation']
      end

      if attributes.has_key?(:'custom_fields')
        if (value = attributes[:'custom_fields']).is_a?(Array)
          self.custom_fields = value
        end
      end

      if attributes.has_key?(:'modified_date')
        self.modified_date = attributes[:'modified_date']
      end

      if attributes.has_key?(:'created_date')
        self.created_date = attributes[:'created_date']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      if @title.nil?
        invalid_properties.push('invalid value for "title", title cannot be nil.')
      end

      if @doi.nil?
        invalid_properties.push('invalid value for "doi", doi cannot be nil.')
      end

      if @handle.nil?
        invalid_properties.push('invalid value for "handle", handle cannot be nil.')
      end

      if @url.nil?
        invalid_properties.push('invalid value for "url", url cannot be nil.')
      end

      if @timeline.nil?
        invalid_properties.push('invalid value for "timeline", timeline cannot be nil.')
      end

      if @account_id.nil?
        invalid_properties.push('invalid value for "account_id", account_id cannot be nil.')
      end

      if @funding.nil?
        invalid_properties.push('invalid value for "funding", funding cannot be nil.')
      end

      if @resource_id.nil?
        invalid_properties.push('invalid value for "resource_id", resource_id cannot be nil.')
      end

      if @resource_doi.nil?
        invalid_properties.push('invalid value for "resource_doi", resource_doi cannot be nil.')
      end

      if @resource_title.nil?
        invalid_properties.push('invalid value for "resource_title", resource_title cannot be nil.')
      end

      if @resource_link.nil?
        invalid_properties.push('invalid value for "resource_link", resource_link cannot be nil.')
      end

      if @resource_version.nil?
        invalid_properties.push('invalid value for "resource_version", resource_version cannot be nil.')
      end

      if @version.nil?
        invalid_properties.push('invalid value for "version", version cannot be nil.')
      end

      if @description.nil?
        invalid_properties.push('invalid value for "description", description cannot be nil.')
      end

      if @categories.nil?
        invalid_properties.push('invalid value for "categories", categories cannot be nil.')
      end

      if @references.nil?
        invalid_properties.push('invalid value for "references", references cannot be nil.')
      end

      if @tags.nil?
        invalid_properties.push('invalid value for "tags", tags cannot be nil.')
      end

      if @authors.nil?
        invalid_properties.push('invalid value for "authors", authors cannot be nil.')
      end

      if @institution_id.nil?
        invalid_properties.push('invalid value for "institution_id", institution_id cannot be nil.')
      end

      if @group_id.nil?
        invalid_properties.push('invalid value for "group_id", group_id cannot be nil.')
      end

      if @articles_count.nil?
        invalid_properties.push('invalid value for "articles_count", articles_count cannot be nil.')
      end

      if @public.nil?
        invalid_properties.push('invalid value for "public", public cannot be nil.')
      end

      if @citation.nil?
        invalid_properties.push('invalid value for "citation", citation cannot be nil.')
      end

      if @custom_fields.nil?
        invalid_properties.push('invalid value for "custom_fields", custom_fields cannot be nil.')
      end

      if @modified_date.nil?
        invalid_properties.push('invalid value for "modified_date", modified_date cannot be nil.')
      end

      if @created_date.nil?
        invalid_properties.push('invalid value for "created_date", created_date cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @id.nil?
      return false if @title.nil?
      return false if @doi.nil?
      return false if @handle.nil?
      return false if @url.nil?
      return false if @timeline.nil?
      return false if @account_id.nil?
      return false if @funding.nil?
      return false if @resource_id.nil?
      return false if @resource_doi.nil?
      return false if @resource_title.nil?
      return false if @resource_link.nil?
      return false if @resource_version.nil?
      return false if @version.nil?
      return false if @description.nil?
      return false if @categories.nil?
      return false if @references.nil?
      return false if @tags.nil?
      return false if @authors.nil?
      return false if @institution_id.nil?
      return false if @group_id.nil?
      return false if @articles_count.nil?
      return false if @public.nil?
      return false if @citation.nil?
      return false if @custom_fields.nil?
      return false if @modified_date.nil?
      return false if @created_date.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          title == o.title &&
          doi == o.doi &&
          handle == o.handle &&
          url == o.url &&
          timeline == o.timeline &&
          account_id == o.account_id &&
          funding == o.funding &&
          resource_id == o.resource_id &&
          resource_doi == o.resource_doi &&
          resource_title == o.resource_title &&
          resource_link == o.resource_link &&
          resource_version == o.resource_version &&
          version == o.version &&
          description == o.description &&
          categories == o.categories &&
          references == o.references &&
          tags == o.tags &&
          authors == o.authors &&
          institution_id == o.institution_id &&
          group_id == o.group_id &&
          articles_count == o.articles_count &&
          public == o.public &&
          citation == o.citation &&
          custom_fields == o.custom_fields &&
          modified_date == o.modified_date &&
          created_date == o.created_date
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, title, doi, handle, url, timeline, account_id, funding, resource_id, resource_doi, resource_title, resource_link, resource_version, version, description, categories, references, tags, authors, institution_id, group_id, articles_count, public, citation, custom_fields, modified_date, created_date].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
