=begin
#Figshare API

#Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.32

=end

require 'date'

module SwaggerClient
  class PrivateFile
    # File id
    attr_accessor :id

    # File name
    attr_accessor :name

    # File size
    attr_accessor :size

    # True if file is hosted somewhere else
    attr_accessor :is_link_only

    # Url for file download
    attr_accessor :download_url

    # File supplied md5
    attr_accessor :supplied_md5

    # File computed md5
    attr_accessor :computed_md5

    # MIME Type of the file, it defaults to an empty string
    attr_accessor :mimetype

    # File viewer type
    attr_accessor :viewer_type

    # File preview state
    attr_accessor :preview_state

    # Upload url for file
    attr_accessor :upload_url

    # Token for file upload
    attr_accessor :upload_token

    # True if the file is attached to a public item version
    attr_accessor :is_attached_to_public_version

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'id' => :'id',
        :'name' => :'name',
        :'size' => :'size',
        :'is_link_only' => :'is_link_only',
        :'download_url' => :'download_url',
        :'supplied_md5' => :'supplied_md5',
        :'computed_md5' => :'computed_md5',
        :'mimetype' => :'mimetype',
        :'viewer_type' => :'viewer_type',
        :'preview_state' => :'preview_state',
        :'upload_url' => :'upload_url',
        :'upload_token' => :'upload_token',
        :'is_attached_to_public_version' => :'is_attached_to_public_version'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'id' => :'Integer',
        :'name' => :'String',
        :'size' => :'Integer',
        :'is_link_only' => :'BOOLEAN',
        :'download_url' => :'String',
        :'supplied_md5' => :'String',
        :'computed_md5' => :'String',
        :'mimetype' => :'String',
        :'viewer_type' => :'String',
        :'preview_state' => :'String',
        :'upload_url' => :'String',
        :'upload_token' => :'String',
        :'is_attached_to_public_version' => :'BOOLEAN'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.has_key?(:'size')
        self.size = attributes[:'size']
      end

      if attributes.has_key?(:'is_link_only')
        self.is_link_only = attributes[:'is_link_only']
      end

      if attributes.has_key?(:'download_url')
        self.download_url = attributes[:'download_url']
      end

      if attributes.has_key?(:'supplied_md5')
        self.supplied_md5 = attributes[:'supplied_md5']
      end

      if attributes.has_key?(:'computed_md5')
        self.computed_md5 = attributes[:'computed_md5']
      end

      if attributes.has_key?(:'mimetype')
        self.mimetype = attributes[:'mimetype']
      end

      if attributes.has_key?(:'viewer_type')
        self.viewer_type = attributes[:'viewer_type']
      end

      if attributes.has_key?(:'preview_state')
        self.preview_state = attributes[:'preview_state']
      end

      if attributes.has_key?(:'upload_url')
        self.upload_url = attributes[:'upload_url']
      end

      if attributes.has_key?(:'upload_token')
        self.upload_token = attributes[:'upload_token']
      end

      if attributes.has_key?(:'is_attached_to_public_version')
        self.is_attached_to_public_version = attributes[:'is_attached_to_public_version']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @size.nil?
        invalid_properties.push('invalid value for "size", size cannot be nil.')
      end

      if @is_link_only.nil?
        invalid_properties.push('invalid value for "is_link_only", is_link_only cannot be nil.')
      end

      if @download_url.nil?
        invalid_properties.push('invalid value for "download_url", download_url cannot be nil.')
      end

      if @supplied_md5.nil?
        invalid_properties.push('invalid value for "supplied_md5", supplied_md5 cannot be nil.')
      end

      if @computed_md5.nil?
        invalid_properties.push('invalid value for "computed_md5", computed_md5 cannot be nil.')
      end

      if @viewer_type.nil?
        invalid_properties.push('invalid value for "viewer_type", viewer_type cannot be nil.')
      end

      if @preview_state.nil?
        invalid_properties.push('invalid value for "preview_state", preview_state cannot be nil.')
      end

      if @upload_url.nil?
        invalid_properties.push('invalid value for "upload_url", upload_url cannot be nil.')
      end

      if @upload_token.nil?
        invalid_properties.push('invalid value for "upload_token", upload_token cannot be nil.')
      end

      if @is_attached_to_public_version.nil?
        invalid_properties.push('invalid value for "is_attached_to_public_version", is_attached_to_public_version cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @id.nil?
      return false if @name.nil?
      return false if @size.nil?
      return false if @is_link_only.nil?
      return false if @download_url.nil?
      return false if @supplied_md5.nil?
      return false if @computed_md5.nil?
      return false if @viewer_type.nil?
      return false if @preview_state.nil?
      return false if @upload_url.nil?
      return false if @upload_token.nil?
      return false if @is_attached_to_public_version.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          id == o.id &&
          name == o.name &&
          size == o.size &&
          is_link_only == o.is_link_only &&
          download_url == o.download_url &&
          supplied_md5 == o.supplied_md5 &&
          computed_md5 == o.computed_md5 &&
          mimetype == o.mimetype &&
          viewer_type == o.viewer_type &&
          preview_state == o.preview_state &&
          upload_url == o.upload_url &&
          upload_token == o.upload_token &&
          is_attached_to_public_version == o.is_attached_to_public_version
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [id, name, size, is_link_only, download_url, supplied_md5, computed_md5, mimetype, viewer_type, preview_state, upload_url, upload_token, is_attached_to_public_version].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
