=begin
#Figshare API

#Figshare apiv2. Using Swagger 2.0

OpenAPI spec version: 2.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.32

=end

require 'date'

module SwaggerClient
  class ProjectCompletePrivate
    # Role inside this project
    attr_accessor :role

    # Project storage type
    attr_accessor :storage

    # Api endpoint
    attr_accessor :url

    # Project id
    attr_accessor :id

    # Project title
    attr_accessor :title

    # Project funding
    attr_accessor :funding

    # Full Project funding information
    attr_accessor :funding_list

    # Project description
    attr_accessor :description

    # List of project collaborators
    attr_accessor :collaborators

    # Project quota
    attr_accessor :quota

    # Project used quota
    attr_accessor :used_quota

    # Date when project was created
    attr_accessor :created_date

    # Date when project was last modified
    attr_accessor :modified_date

    # Project private quota used
    attr_accessor :used_quota_private

    # Project public quota used
    attr_accessor :used_quota_public

    # Group of project if any
    attr_accessor :group_id

    # ID of the account owning the project
    attr_accessor :account_id

    # Collection custom fields
    attr_accessor :custom_fields

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'role' => :'role',
        :'storage' => :'storage',
        :'url' => :'url',
        :'id' => :'id',
        :'title' => :'title',
        :'funding' => :'funding',
        :'funding_list' => :'funding_list',
        :'description' => :'description',
        :'collaborators' => :'collaborators',
        :'quota' => :'quota',
        :'used_quota' => :'used_quota',
        :'created_date' => :'created_date',
        :'modified_date' => :'modified_date',
        :'used_quota_private' => :'used_quota_private',
        :'used_quota_public' => :'used_quota_public',
        :'group_id' => :'group_id',
        :'account_id' => :'account_id',
        :'custom_fields' => :'custom_fields'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'role' => :'String',
        :'storage' => :'String',
        :'url' => :'String',
        :'id' => :'Integer',
        :'title' => :'String',
        :'funding' => :'String',
        :'funding_list' => :'Array<FundingInformation>',
        :'description' => :'String',
        :'collaborators' => :'Array<Collaborator>',
        :'quota' => :'Integer',
        :'used_quota' => :'Integer',
        :'created_date' => :'String',
        :'modified_date' => :'String',
        :'used_quota_private' => :'Integer',
        :'used_quota_public' => :'Integer',
        :'group_id' => :'Integer',
        :'account_id' => :'Integer',
        :'custom_fields' => :'Array<CustomArticleField>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'role')
        self.role = attributes[:'role']
      end

      if attributes.has_key?(:'storage')
        self.storage = attributes[:'storage']
      end

      if attributes.has_key?(:'url')
        self.url = attributes[:'url']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'title')
        self.title = attributes[:'title']
      end

      if attributes.has_key?(:'funding')
        self.funding = attributes[:'funding']
      end

      if attributes.has_key?(:'funding_list')
        if (value = attributes[:'funding_list']).is_a?(Array)
          self.funding_list = value
        end
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'collaborators')
        if (value = attributes[:'collaborators']).is_a?(Array)
          self.collaborators = value
        end
      end

      if attributes.has_key?(:'quota')
        self.quota = attributes[:'quota']
      end

      if attributes.has_key?(:'used_quota')
        self.used_quota = attributes[:'used_quota']
      end

      if attributes.has_key?(:'created_date')
        self.created_date = attributes[:'created_date']
      end

      if attributes.has_key?(:'modified_date')
        self.modified_date = attributes[:'modified_date']
      end

      if attributes.has_key?(:'used_quota_private')
        self.used_quota_private = attributes[:'used_quota_private']
      end

      if attributes.has_key?(:'used_quota_public')
        self.used_quota_public = attributes[:'used_quota_public']
      end

      if attributes.has_key?(:'group_id')
        self.group_id = attributes[:'group_id']
      end

      if attributes.has_key?(:'account_id')
        self.account_id = attributes[:'account_id']
      end

      if attributes.has_key?(:'custom_fields')
        if (value = attributes[:'custom_fields']).is_a?(Array)
          self.custom_fields = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @url.nil?
        invalid_properties.push('invalid value for "url", url cannot be nil.')
      end

      if @id.nil?
        invalid_properties.push('invalid value for "id", id cannot be nil.')
      end

      if @title.nil?
        invalid_properties.push('invalid value for "title", title cannot be nil.')
      end

      if @funding.nil?
        invalid_properties.push('invalid value for "funding", funding cannot be nil.')
      end

      if @funding_list.nil?
        invalid_properties.push('invalid value for "funding_list", funding_list cannot be nil.')
      end

      if @description.nil?
        invalid_properties.push('invalid value for "description", description cannot be nil.')
      end

      if @collaborators.nil?
        invalid_properties.push('invalid value for "collaborators", collaborators cannot be nil.')
      end

      if @quota.nil?
        invalid_properties.push('invalid value for "quota", quota cannot be nil.')
      end

      if @used_quota.nil?
        invalid_properties.push('invalid value for "used_quota", used_quota cannot be nil.')
      end

      if @created_date.nil?
        invalid_properties.push('invalid value for "created_date", created_date cannot be nil.')
      end

      if @modified_date.nil?
        invalid_properties.push('invalid value for "modified_date", modified_date cannot be nil.')
      end

      if @used_quota_private.nil?
        invalid_properties.push('invalid value for "used_quota_private", used_quota_private cannot be nil.')
      end

      if @used_quota_public.nil?
        invalid_properties.push('invalid value for "used_quota_public", used_quota_public cannot be nil.')
      end

      if @group_id.nil?
        invalid_properties.push('invalid value for "group_id", group_id cannot be nil.')
      end

      if @account_id.nil?
        invalid_properties.push('invalid value for "account_id", account_id cannot be nil.')
      end

      if @custom_fields.nil?
        invalid_properties.push('invalid value for "custom_fields", custom_fields cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      role_validator = EnumAttributeValidator.new('String', ['Owner', 'Collaborator', 'Viewer'])
      return false unless role_validator.valid?(@role)
      storage_validator = EnumAttributeValidator.new('String', ['individual', 'group'])
      return false unless storage_validator.valid?(@storage)
      return false if @url.nil?
      return false if @id.nil?
      return false if @title.nil?
      return false if @funding.nil?
      return false if @funding_list.nil?
      return false if @description.nil?
      return false if @collaborators.nil?
      return false if @quota.nil?
      return false if @used_quota.nil?
      return false if @created_date.nil?
      return false if @modified_date.nil?
      return false if @used_quota_private.nil?
      return false if @used_quota_public.nil?
      return false if @group_id.nil?
      return false if @account_id.nil?
      return false if @custom_fields.nil?
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] role Object to be assigned
    def role=(role)
      validator = EnumAttributeValidator.new('String', ['Owner', 'Collaborator', 'Viewer'])
      unless validator.valid?(role)
        fail ArgumentError, 'invalid value for "role", must be one of #{validator.allowable_values}.'
      end
      @role = role
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] storage Object to be assigned
    def storage=(storage)
      validator = EnumAttributeValidator.new('String', ['individual', 'group'])
      unless validator.valid?(storage)
        fail ArgumentError, 'invalid value for "storage", must be one of #{validator.allowable_values}.'
      end
      @storage = storage
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          role == o.role &&
          storage == o.storage &&
          url == o.url &&
          id == o.id &&
          title == o.title &&
          funding == o.funding &&
          funding_list == o.funding_list &&
          description == o.description &&
          collaborators == o.collaborators &&
          quota == o.quota &&
          used_quota == o.used_quota &&
          created_date == o.created_date &&
          modified_date == o.modified_date &&
          used_quota_private == o.used_quota_private &&
          used_quota_public == o.used_quota_public &&
          group_id == o.group_id &&
          account_id == o.account_id &&
          custom_fields == o.custom_fields
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [role, storage, url, id, title, funding, funding_list, description, collaborators, quota, used_quota, created_date, modified_date, used_quota_private, used_quota_public, group_id, account_id, custom_fields].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = SwaggerClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
